#!/bin/sh

# 指定されたディレクトリの内容を、DiskCopy 6のディスク・イメージ形式でアーカイブする。

MACOSX_TYPE="apple-darwin";

if ( echo $MACHTYPE | grep $MACOSX_TYPE >/dev/null ) then
	SRC=$1									# アーカイブするディレクトリ
	DST=$2									# 生成するディスク・イメージ・ファイル名
	NAME=$3									# アーカイブの名称
	TMP=/tmp/$(basename $0)_$$				# 作業用ディレクトリ
	TMP_SRC=$TMP/$NAME
	TMP_DMG=$TMP/work.dmg
	
	# ディスク・イメージ・ファイルが存在していたら、念のためアンマウントしておく。
	if [ -f $DST ]; then
		hdiutil detach $(basename $(hdid -nomount $DST | cut -f 1))
	fi

	# アーカイブ先のファイルおよび作業用ディレクトリを削除する。
	rm -f  $DST $TMP_DMG
	rm -rf $TMP

	# アーカイブするファイルを、作業用ディレクトリへコピーする。
	ditto -rsrcFork $SRC $TMP_SRC
	rm -f  $TMP_SRC/.[A-Z]* $TMP_SRC/*/.[A-Z]* $TMP_SRC/*.img $TMP_SRC/*.zip
	rm -rf $TMP_SRC/.Trashes

	# dmg形式の作業用ディスク・イメージを作成し、マウントする。
	hdiutil create $TMP_DMG -size 1440k -layout NONE -fs HFS -volname $NAME
	hdiutil attach $TMP_DMG

	# 作業用ファイルをアーカイブしてマウントしたイメージへ保存し、アンマウントする。
	DEVICE=$(basename $(hdid -nomount $TMP_DMG | cut -f 1))
	ditto -rsrcFork $TMP_SRC /Volumes/$NAME
	hdiutil detach $DEVICE

	# dmg形式の作業用ディスク・イメージをDiskCopy 6形式へ変換する。
	hdiutil convert $TMP_DMG -format ROCo -o $DST
	
	# 作業用ディレクトリを削除する。
	rm -f  $TMP_DMG
	rm -rf $TMP
fi
