#!/bin/sh

# 指定されたディレクトリの内容を、ZIP形式でアーカイブする。

MACOSX_TYPE="powerpc-apple-darwin";

if ( echo $MACHTYPE | grep $MACOSX_TYPE >/dev/null ) then
	SRC=$1									# アーカイブするディレクトリ
	DST=$2									# アーカイブの出力先ファイル名
	NAME=$3									# アーカイブの名称
	TMP=/tmp/$(basename $0)_$$				# 作業用ディレクトリ
	TMP_SRC=$TMP/$NAME
	
	# アーカイブ先のファイルおよび作業用ディレクトリを削除する。
	rm -f  $DST
	rm -rf $TMP

	# アーカイブするファイルを、作業用ディレクトリへコピーする。
	ditto -rsrcFork $SRC $TMP_SRC
	rm -f  $TMP_SRC/.[A-Z]* $TMP_SRC/*/.[A-Z]* $TMP_SRC/*.img $TMP_SRC/*.zip
	rm -rf $TMP_SRC/.Trashes

	# 作業用ファイルをアーカイブする。
	ditto -c -k --sequesterRsrc --keepParent $TMP_SRC $DST
	
	# 作業用ディレクトリを削除する。
	rm -rf $TMP
fi
