// 東芝RDシリーズ DVD／HDDレコーダの“ネットdeダビング”機能に特化したFTPサーバの簡易的な実装

//  Created by raktajino on Sun Nov. 21 2004.
//  Copyright (c) 2004 raktajino. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

package com.mac.raktajino.RDService;

import java.io.*;
import java.net.*;

public class FTPService extends Thread {

	protected int		fFTPControlPort;
	protected int		fFTPDataPortFrom;
	protected int		fFTPDataPortTo;
	protected int		fFTPBufferSize;
	protected String	fDstDirectory;

	// --- コンストラクタ

	FTPService(int controlPort, int dataPortFrom, int dataPortTo, int bufferSize, String dstDirectory)
	{
		fFTPControlPort  = controlPort;
		fFTPDataPortFrom = dataPortFrom;
		fFTPDataPortTo   = dataPortTo;
		fFTPBufferSize   = bufferSize;
		fDstDirectory    = dstDirectory;
	}
	
	// --- スレッドの本体を実行する。
	
	public void run()
	{
		try {
			this.doFTPService();
		}
        catch(Exception e) {
            System.err.println("FTP service : " + e.getMessage());
        }
	}

	// --- FTPセッションの開始を待ち、セッションの処理を別スレッドで実行する。
	
	protected void doFTPService()
		throws IOException
	{
    	ServerSocket ftpControlSocket = new ServerSocket(fFTPControlPort);
		try {
			while(true) {
				Socket controlSocket = ftpControlSocket.accept();
				if(controlSocket != null) {
					FTPSession session = new FTPSession(controlSocket, fFTPDataPortFrom, fFTPDataPortTo, fFTPBufferSize, fDstDirectory);
					session.start();
				}
			}
		}
		finally {
			ftpControlSocket.close();
		}
	}
}
