// 東芝RDシリーズ DVD／HDDレコーダからのNETBIOS Name Serviceによる名称問い合わせに応答する。

// 2ちゃんねるAV機器板の「東芝HDD＆DVDﾚｺ ネットdeダビング解析」スレッドでの解析情報と、
// 151◆HdSsCCrBb氏が作成されたPerl版vrd2のコードを参考にさせていただきました。
// 貴重な情報をご公開いただき、ありがとうございました。
//
// 東芝HDD＆DVDﾚｺ ネットdeダビング解析 2
// http://hobby7.2ch.net/test/read.cgi/av/1093141161/
//
// 151◆HdSsCCrBb氏のPerl版vrd
// http://www.geocities.co.jp/SiliconValley-Cupertino/9578/vrd2.zip 

//  Created by raktajino on Sun Nov. 21 2004.
//  Copyright (c) 2004 raktajino. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

package com.mac.raktajino.RDService;

import java.io.*;
import java.net.*;
import sun.misc.HexDumpEncoder;
import sun.misc.CharacterEncoder;

public class NameService extends Thread {

    public    static final int		kMaxLength = 512;				// UDPパケットの最大バイト数
    public    static final boolean	kCouldUseInetSocketAddress;		// InetSocketAddressクラスは利用可能か？

	protected              int		fNetBIOSNSPort;
	protected              String	fServiceName;
	
	static
	{
		// InetSocketAddressクラスが使用可能であるかどうか確認する。
		boolean couldUseInetSocketAddress = false;
		try {
			new InetSocketAddress(0);
			couldUseInetSocketAddress = true;
		}
		catch(NoClassDefFoundError e) {
		}
		kCouldUseInetSocketAddress = couldUseInetSocketAddress;
	}
	
	// --- コンストラクタ
	
	NameService(int port, String serviceName)
	{
		fNetBIOSNSPort = port;
		fServiceName   = serviceName;
	}

	// --- スレッドの本体を実行する。
	
	public void run()
	{
        try {
			this.doNameService();
		}
        catch(Exception e) {
            System.err.println("Name service : " + e.getMessage());
        }
	}

	// --- RDからのNETBIOS Name Serviceブロードキャストを処理する。
	
    protected void doNameService()
		throws IOException, UnsupportedEncodingException
	{
		DatagramSocket socket = null;
        try {
			// 待ち受け用のソケットを作成する。
			if(kCouldUseInetSocketAddress) {
				socket = new DatagramSocket(null);
				socket.setReuseAddress(true);
				socket.bind(new InetSocketAddress(fNetBIOSNSPort));
			}
			else {
 				socket = new DatagramSocket(fNetBIOSNSPort);
			}
			
 			byte[]         data   = new byte[kMaxLength];
            DatagramPacket packet = new DatagramPacket(data, kMaxLength);
            while(true) {
 				// ブロードキャストを受信する。
				socket.receive(packet);
                data = packet.getData();

				// レスポンスを返す。
                int    dataLength  = packet.getLength();
				String decodedName = this.decodeString(data, 13, dataLength - 13);
				if(decodedName.startsWith("GR-")) {
               		System.out.println("Name service query from : " + decodedName);
					this.sendResponse(data, socket.getLocalAddress(), packet.getAddress());
				}
            }
        }
        finally {
            if(socket != null) {
				socket.close();
			}
        }
    }
	
	// --- RDからのNETBIOS Name Serviceブロードキャストに対するレスポンスを返す。
	
	protected void sendResponse(byte[] queryData, InetAddress localAddress, InetAddress remoteAddress)
		throws IOException, UnsupportedEncodingException
	{
		byte[] myAddress    = localAddress.getAddress();
		byte[] encodedName  = this.encodeString(fServiceName.concat("               ").substring(0, 16).concat("\000"));
		byte[] data         = new byte[62];
		data[0]  = 0x01;							// Device Flag
		data[1]  = queryData[1];					// Transaction ID
		data[2]  = (byte)0x85;						// Flag
		data[3]  = 0x00;
		data[4]  = 0x00;							// Quesion
		data[5]  = 0x00;
		data[6]  = 0x00;							// Answer
		data[7]  = 0x01;
		data[8]  = 0x00;							// Authority
		data[9]  = 0x00;
		data[10] = 0x00;							// Additional
		data[11] = 0x00;
		data[12] = (byte)encodedName.length;		// Name
		System.arraycopy(encodedName, 0, data, 13, encodedName.length);
		data[45] = 0x00;
		data[46] = 0x00;							// Type
		data[47] = 0x20;
		data[48] = 0x00;							// Class
		data[49] = 0x01;
		data[50] = 0x00;							// TTL
		data[51] = 0x00;
		data[52] = 0x00;
		data[53] = 0x00;
		data[54] = 0x00;							// Length
		data[55] = 0x06;
		data[56] = 0x00;							// Answer Flag
		data[57] = 0x00;
		data[58] = myAddress[0];					// IP
		data[59] = myAddress[1];
		data[60] = myAddress[2];
		data[61] = myAddress[3];

		DatagramSocket socket = new DatagramSocket();
		try {
			DatagramPacket packet = new DatagramPacket(data, data.length, remoteAddress, fNetBIOSNSPort);
			socket.send(packet);
		}
		finally {
			socket.close();
		}
	}

	// --- 名前をエンコードする。
	
	protected byte[] encodeString(String raw)
		throws UnsupportedEncodingException
	{
		byte[] encodedArray = new byte[raw.length() * 2];
		byte[] rawArray     = raw.getBytes("iso-8859-1");
		for(int n = 0; n < rawArray.length; n++) {
			encodedArray[n * 2]     = (byte)(((rawArray[n] >> 4) & 0xf) + 0x41);
			encodedArray[n * 2 + 1] = (byte)(( rawArray[n]       & 0xf) + 0x41);
		}
		return encodedArray;
	}

	// --- 名前をデコードする。
	
	protected String decodeString(byte[] encodedArray, int offset, int length)
		throws UnsupportedEncodingException
	{
		byte         ch[]   = new byte[1];
		StringBuffer buffer = new StringBuffer();
		for(int n = offset; n < length; n += 2) {
			ch[0] = (byte)(((encodedArray[n] - 0x41) << 4) + ((encodedArray[n + 1] - 0x41) & 0xf));
			buffer.append(new String(ch, "iso-8859-1"));
		}
		return new String(buffer);
	}
	
	// --- 指定されたbyte配列の内容を表示する。（デバッグ用）

	protected void dumpByteArray(byte[] array, int length)
		throws IOException
	{
        CharacterEncoder encoder = new HexDumpEncoder();
        encoder.encode(new ByteArrayInputStream(array, 0, length), System.out);
	}
}
